/*--------------------------------------------------------------------.
| mchoice.c							      |
| 								      |
| Copyright (c) 1997 Jonathan Hudson				      |
| 								      |
| You may distribute under the terms of either the GNU General Public |
| License or the Artistic License, as specified in the README file.   |
`--------------------------------------------------------------------*/

static char rcsid[] = "$Id: mchoice.c,v 1.4 1997/11/15 14:33:02 jrh Rel $";

/*
 * $Log: mchoice.c,v $
 * Revision 1.4  1997/11/15 14:33:02  jrh
 * reindented for release 1.05
 *
 * Revision 1.3  1997/10/12 20:41:40  jrh
 * indented source code
 *
 * Revision 1.2  1997/10/05 19:52:37  jrh
 * Enhanced dynamic memory allocations
 *
 * Revision 1.1  1997/10/02 21:28:29  jrh
 * Initial revision
 *
 */

#include <stdio.h>
#include <qdos.h>
#include <qptr.h>
#include <stdarg.h>
#include <string.h>
#include "qascade.h"

static long ACHOICE (struct WM_wwork *, struct WM_litm *, struct WM_wstat *);
static struct WM_action achoice =
{JSR, wm_actli, ACHOICE};

#define PR_MAX 60
#define LTXT_MAX 20
#define YSIZE 27
#define MINX 48
#define BORD_X 4
#define NLITM_MAX 39

static long ACHOICE (WM_wwork_t * wwk, WM_litm_t * li, WM_wstat_t * wst)
{
    wst->litem[NLITM_MAX] = li->item;
    return PT__CAN;
}

int menu_choice (WM_wwork_t * wwk, char *prompt, int nlitm, int itptr,...)
{
    va_list nxlitm;
    char *itxt, *ltp;
    int icount;
    short pulld_wid, pr_wid, lit_wid;
    WM_wstat_t *ws;
    WM_info_t *info;
    WM_infw_t *infw;
    WM_litm_t *litm;
    WM_wwork_t *ww;
    QD_text_t *qprompt;
    QD_text_t *ltxt;

    /*----------------------------------------------.
    | Allocate all the memory we need in one hunk.  |
    | We build up the menu structures dynamically   |
    `----------------------------------------------*/

    ws = xalloc (sizeof (WM_wstat_t) +
		 (2 * sizeof (WM_info_t)) +
		 (3 * sizeof (WM_infw_t)) +
		 ((nlitm + 1) * sizeof (WM_litm_t)) +
		 (sizeof (WM_wwork_t)) +
		 (sizeof (short) + PR_MAX) +
		  (6 * (sizeof (short) + LTXT_MAX)));

    info = (WM_info_t *) (ws + 1);
    infw = (WM_infw_t *) (info + 2);
    litm = (WM_litm_t *) (infw + 3);
    ww = (WM_wwork_t *) (litm + (nlitm + 1));
    qprompt = (QD_text_t *) (ww + 1);
    ltxt = (QD_text_t *) ((char *) qprompt + sizeof (short) + PR_MAX);

    qprompt->len = strlen (prompt);
    strcpy ((char *) qprompt->chrs, prompt);

    lit_wid = 0;
    va_start (nxlitm, itptr);

    ltp = (char *) ltxt;
    for (icount = 0; icount < nlitm; icount++)
    {
	short n;
	itxt = va_arg (nxlitm, char *);
	*(short *) ltp = n = strlen (itxt);
	strcpy (ltp + 2, itxt);
	if (n > lit_wid)
	    lit_wid = n;
	ltp += sizeof (short) + LTXT_MAX;
    }

    pulld_wid = (lit_wid * 6 + 10) * nlitm;

    pr_wid = (qprompt->len + 2) * 6;

    if (pr_wid > pulld_wid)
	pulld_wid = pr_wid;

    pulld_wid = ((pulld_wid + 11) / 12) * 12;
    lit_wid = (pulld_wid / nlitm) - 4;	/* width of each item */

    ww->xsize = pulld_wid + (BORD_X * 2);
    ww->ysize = YSIZE;
    ww->xorg = itptr * (lit_wid + 4) + 8;
    ww->yorg = YSIZE - 4;
    ww->flag = 2;
    ww->borw = 1;
    ww->borc = CL_MBORD;
    ww->papr = CL_MBACK;
    ww->curw = 1;
    ww->curc = CL_MHIGH;
    ww->uback = CL_MPUNAV;
    ww->uink = CL_MIUNAV;
    ww->aback = CL_MPAVBL;
    ww->aink = CL_MIAVBL;
    ww->sback = CL_MPSLCT;
    ww->sink = CL_MISLCT;
    ww->ninfo = 2;
    ww->ninob = 1;
    ww->pinfo = infw;
    ww->nlitm = nlitm;
    ww->plitm = litm;

    (infw + 0)->xsize = (infw + 1)->xsize = pulld_wid;
    (infw + 0)->ysize = 12;
    (infw + 0)->xorg = (infw + 1)->xorg = BORD_X;
    (infw + 0)->yorg = 13;
    (infw + 0)->borw = 1;
    (infw + 0)->borc = 255;
    (infw + 0)->papr = 84;

    (infw + 1)->ysize = 10;
    (infw + 1)->yorg = 1;
    (infw + 1)->flag = NO_WCLEAR;
    (infw + 1)->papr = CL_MBACK;
    (infw + 1)->pobl = info;

    (infw + 2)->xsize = -1;

    (info + 0)->xsize = pr_wid - 6;
    (info + 0)->ysize = 10;
    (info + 0)->xorg = (pulld_wid - pr_wid) / 2 + 3;
    (info + 0)->yorg = 0;
    (info + 0)->type = TYP_TEXT;
    (info + 0)->pobj = qprompt;
    (info + 1)->xsize = -1;

    ltp = (char *) ltxt;
    for (icount = 0; icount < nlitm; icount++)
    {
	(litm + icount)->xsize = lit_wid;
	(litm + icount)->ysize = 10;
	(litm + icount)->xorg = BORD_X + 2 + icount * (lit_wid + 4);
	(litm + icount)->yorg = 14;
	(litm + icount)->type = TYP_TEXT - 1;
	(litm + icount)->pact = &achoice;
	(litm + icount)->pobj = ltp;
	(litm + icount)->item = icount;
	(litm + icount)->skey = ltxt->chrs[0];
	ltp += sizeof (short) + LTXT_MAX;
    }
    (litm + nlitm)->xsize = -1;	/* ensure that there is a -1 at end of list */

    ws->citem = -1;		/* no current item  */
    ws->ciact = NULL;		/* or current item routine */
    ws->litem[NLITM_MAX] = -1;	/* preset ESC return */

    ws->wwork = ww;		/* cross references */
    ww->wstat = ws;
    ws->wmode = FORM_QL4;

    wm_pulld (ww, wwk->xorg + 50, wwk->yorg + 50);	/* pull down */
    wm_wdraw (ww);

    while (!wm_rptr (ww))
    {
	if (ws->evnt & PT_CAN)
	    break;
    }
    wm_cluns (ww);		/* throw it away */
    icount = ws->litem[NLITM_MAX];
    xfree (ws);
    return icount;
}
