#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

char _prog_name[] = "mClock";
char _version[] = "0.03";

long (*_cmdchannels) (long) = NULL;
long (*_stackchannels) (long) = NULL;
void (*_consetup) (chanid_t,struct WINDOWDEF *) = NULL;
long (*_conread) () = NULL;
long (*_conwrite) () = NULL;
char *_endmsg = NULL;

static struct WM_wstat ws =	/* window status area */
{
    NULL,			/* *wwork point back to work def */
    NULL,			/* *wdef this was wdef */
    0,				/* chid chan ID enclosing pointer */
    0, 0, 0,			/* swnr, xpos, ypos sub-window and ptr posn */
    0, 0,			/* kstk, kprs key stroke and press */
    0,				/* evnt event vector */
    0, 0, 0, 0,			/* xsiz, ysiz, xorg, yorg  */
    0, 0,			/* ptpsx, ptpsy pointer position (abs) */
    FORM_QL4, 0, 0,		/* wmode, 2 spare window mode and spare */
    NULL,			/* *ciact current item "action" */
    -1,				/* citem  current item */
    0, 0, 0,			/* cibrw, cipap, cispr  current item attr */
    0, 0, 0, 0,			/* cihxs,ys, cihxo,yo   current item hit area */
    {0, 0, 0, 0, 0, 0, 0, 0}	/* litem[40] loose item status */
};


static struct WM_infw infw[1+1] =	/* information window */
{
    {84, 10,			/* xsize, ysize size */
     0, 1,			/* xorg, yorg and origin */
     0,				/* flag no clear + shadow */
     0, 0, 7,			/* borw, borc, papr border width/clr,paper */
     NULL},			/* *pobj pointer to object list */
    {-1}			/* end of array */
};

static struct WM_wwork ww =	/* window working definition */
{
    NULL,			/* *wstat pointer to status area */
    NULL,			/* *wscale this was pointer to WDEF */
    0,			        /* chid channel ID */
    NULL,			/* *pprec pointer to pointer record */
    0,			        /* psave pointer position saved */
    0, 0, 0, 0,		        /* 4 zero */
    NULL,			/* *splst pointer to sprite list */
    84, 12,			/* xsize, ysize         size */
    0, 0,			/* xorg, yorg           and origin */
    0,			        /* flag no clear + shadow */
    1, CL_BBORD, CL_MBACK,	/* borw, borc, papr border width/clr, paper */
    NULL,			/* *sprite  pointer to sprite */
    1, CL_MHIGH,		/* curw, curc current item width/clr */
    CL_MPUNAV, CL_MIUNAV, NULL, NULL, /* uback, uink, *ublob, *upatt unavail */
    CL_BPAVBL, CL_BIAVBL, NULL, NULL, /* aback, aink, *ablob, *apatt avail */
    CL_BPSLCT, CL_BISLCT, NULL, NULL, /* sback, sink, *sblob, *spatt selected */
    NULL,			/* *help */
    1, 0, infw,		        /* ninfo, ninob, *pinfo info winds */
    0, NULL,		        /* nlitm, *plitm loose items */
    0, NULL			/* nappl  *pappl appl winds */
};


void refresh(void)
{
    bt_free();
    bt_prpos(&ww);
    wm_wdraw(&ww);
}

void execute(char *envar)
{
    char *prog, *cmd, *s;
    chanid_t chid;
    int jobid, rv = -1;

    if((prog = getenv(envar)) != NULL)
    {
        if((s = strchr(prog, ' ')))
        {
            *s = 0;
            cmd = s+1;
        }
        else cmd = NULL;
    
        if ((rv = io_open (prog, 0)) > 0)
        {
            struct qdirect qdir;
            void *jobaddr;
            struct JOBHEADER *jh;	/* ha ha */
            long codsiz;
            short elen, nlen;

            chid = rv;
            if ((rv = fs_headr (chid, -1, &qdir, sizeof (qdir))) > 0)
            {
                if (qdir.d_type == QF_PROG_TYPE)
                {
                    jobid = mt_cjob (qdir.d_length, qdir.d_datalen, NULL, 0,
                                     (char **)&jobaddr);
                    if (jobid > 0)
                    {
                        void *stk;
                        
                        if ((rv = fs_load (chid, jobaddr, qdir.d_length)) > 0)
                        {
                            io_close (chid);
                            chid = 0;
                            jh = (((struct JOBHEADER *) jobaddr) - 1);
                            stk = (void *) jh->jb_regs.jb_A7;
                            if (cmd && (nlen = strlen (cmd)))
                            {
                                elen = (nlen + 1) & ~1;
                            }
                            else
                            {
                                nlen = elen = 0;
                            }
                            
                            ((char *) stk) -= elen;
                            (void *) jh->jb_regs.jb_A7 = stk;
                            *((short *) stk)++ = 0;
                            *((short *) stk)++ = nlen;
                            while (nlen--)
                            {
                                *((char *) stk)++ = *cmd++;
                            }
                            rv = mt_activ (jobid, 8, 0);
                        }
                        else
                        {
                            mt_frjob (jobid, rv);
                        }
                    }
                }
                else
                {
                    rv = -15;
                }
            }
            if (chid > 0)
            {
                io_close (chid);
            }
        }
        free(prog);
    }
}

int main (int ac, char **av)
{
    int res = 0;
    int n,l = 0;
    short nc,first = 1;
    static QLSTR_INIT(str, "mClock 0.03 (c) jh 1997-8\n");
    char *sp;
    
    ws.wwork = &ww;	
    ww.wstat = &ws;


    sp = *(av + 1);
    nc = *((short *) sp);
    sp += (2 + (nc << 2));
    if ((nc = *((short *) sp)))
    {
        sp += 2;
        if(*sp == '-' && *(sp+1) == 'p')
        {
            int p;
            *(sp+nc) = 0;
            if((p = atoi(sp+2)))
            {
                mt_prior(-1, p);
            }
        }
    }
    
    ut_mtext(0, (QLSTR_t *)&str);
    
    if((ww.chid = io_open("scr", 0)) > 0)
    {

        if (wm_findv (ww.chid) == NULL)
        {
            return ERR_NF;
        }

        l = *(long*)(_sys_var+0x20);
        l = l >> 10;
        nc = (l > 9999) ? 5 : (l > 999) ? 4 : 3;
        
        ww.xsize = (infw+0)->xsize = 60 + (nc * 6);
        
        res = bt_prpos (&ww);
        if(res == 0)
        {
            short lx = 0,ly = 0;
            WM_prec_t prec;
            QD_TEXT(32) qtim;
            time_t t;
            char *p;
            static short jl[3] = {100,1000,10000};
            
            if((res = wm_wdraw (&ww)) == 0)
            {
                if((res = wm_swinf(&ww, 0, 0)) >= 0)
                {
                    while(1)
                    {
                        short i,j,k=0;
                        t = mt_rclck();
                        cn_date((char *) &qtim, t);
                        n = mt_free();
                        n = n >> 10;
                        
                        p = (char*)qtim.chrs+20;
                        *p++ = ' ';
                    
                        for(j = jl[nc-3];j;)
                        { 
                            i = n / j;
                            *p++ = (i || k) ? k++,i+'0' : ' ';
                            n = n % j;
                            j = j / 10;
                        }
                        *(p-1) |= '0';
                        *p++ = 'K';
                        sd_pos(ww.chid, -1, 0, 0);
                        io_sstrg(ww.chid, -1, (char *) qtim.chrs+12, 10+nc);
                    
                        if(iop_rptr(ww.chid, 50, &lx, &ly, 0x1, &prec) == 0)
                        {
                            if(prec.kstk == 27)
                            {
                                break;
                            }
                            else if(prec.kstk == 1)
                            {
                                execute("MCLICK_1");
                            }
                            else if(prec.kstk == 2)                    
                            {
                                execute("MCLICK_2");
                            }
                            else if(prec.kstk == 8)
                            {
                                refresh();
                            }
                        }
                        else if(first)
                        {
                            first = 0;
                            refresh();
                        }
                    }
                }
            }
        }
    }
    else res = ww.chid;
    return (res >= 0) ? 0 : res;
}
int (*_Cstart) () = main;


  
